import pandas as pd
import lxml.etree as et
import logging

def get_attrs(input_file):
    attrs = []
    images = 1
    for event, elem in et.iterparse(input_file):
        if elem.tag == "o":
            images_counter = 1
            for attribute in elem.find('attrs').findall('a'):
                if (attribute.attrib['name'] not in attrs):
                    attrs.append(attribute.attrib['name'])
            for image in elem.find('imgs').findall('i'):
                images_counter += 1
            if images_counter > images:
                images = images_counter
                print(elem.attrib['id'] + ' has ' + str(images) + ' images and it is maximum for this document')
    return attrs, images

def readOldCSV(file, new_name):
    root = et.Element('offers')
    variant_counter = 0
    df = pd.read_csv(file, delimiter = ';')
    products = df.to_dict('records')
    for prod in products:
        entry = {
            'id': "None",
            'url': "shumee.pl",
            'price': "None",
            'avail': "0",
            'stock': "None",
            'cat': "None",
            'name': "None",
            'images': [],
            'desc': "None",
            'attrs': {}
        }
        
        counter = 1
        for image in prod:
            if image[:7] == 'Zdjęcie':
                entry['images'].append(prod[image])
                counter += 1
                if counter == 13:
                    break
        
        
        entry['id'] = prod['SKU']
        
        entry['price'] = prod['Cena końcowa w walucie platformy']
        
        entry['stock'] = prod['Stan magazynowy']
        if int(entry['stock']) > 0:
            entry['avail'] = '1'
        else:
            entry['avail'] = '0'
        
        entry['attrs']['width'] = prod['Szerokość']
        entry['attrs']['length'] = prod['Długość']
        entry['attrs']['width'] = prod['Szerokość']
        entry['attrs']['weight'] = prod['Waga']

        entry['cat'] = prod['Kategoria']
        
        entry['name'] = prod['Nazwa produktu']
        
        entry['desc'] = prod['Opis']
        
        entry['attrs']['Kod_producenta'] = prod['SKU']
        entry['attrs']['EAN'] = prod['EAN']
        entry['attrs']['brand'] = prod['Producent']
        
        root = save(entry, root)
        logging.info('Successfully appended entry ' + str(entry['id']))
    xml_to_save = et.ElementTree(root)
    with open(new_name, 'wb') as f:
        xml_to_save.write(f, pretty_print=True, xml_declaration=True, method='xml', encoding='utf-8')
    

def save(entry, root):
    offer = et.SubElement(root, "o", id=str(entry['id']), url=str(entry['url']), price=str(entry['price']), avail=str(entry['avail']), stock=str(entry['stock']))
    
    category = et.SubElement(offer, "cat")
    category.text = et.CDATA(str(entry["cat"]))
    
    name = et.SubElement(offer, "name")
    name.text = et.CDATA(str(entry["name"]))
    
    desc = et.SubElement(offer, "desc")
    desc.text = et.CDATA(str(entry["desc"]))
    
    imgs = et.SubElement(offer, "imgs")
    if entry['images']:
        main = et.SubElement(imgs, "main", url=entry["images"][0])
        for image in entry["images"][1:]:
            i = et.SubElement(imgs, "i", url=str(image))
    
    attrs = et.SubElement(offer, "attrs")
    for key in entry["attrs"]:
        a = et.SubElement(attrs, "a", name=key)
        a.text = et.CDATA(str(entry["attrs"][key]))
    return root

def execute(old_name, new_name): 
    readOldCSV(old_name, new_name)